<!DOCTYPE HTML>
<html>

<head>
    <title>YourWebHelper</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no" />
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.2.1/dist/css/bootstrap.min.css"
        integrity="sha384-GJzZqFGwb1QTTN6wy59ffF1BuGJpLSa9DkKMp0DgiMDm4iYMj70gZWKYbI706tWS"
        crossorigin="anonymous">
    <link rel="stylesheet" href="static/css/main.css" />
    <noscript><link rel="stylesheet" href="static/css/noscript.css" /></noscript>
    <style>
        #loading-message {
            font-size: 5rem;
            /* Tamaño de fuente */
            text-align: center;
            animation: bounce 2s infinite;
            /* Animación de rebote infinita */
        }

        @keyframes bounce {
            0%, 20%, 50%, 80%, 100% {
                transform: translateY(0);
                /* Posición inicial y final */
            }

            40% {
                transform: translateY(-10px);
                /* Punto más alto del rebote */
            }

            60% {
                transform: translateY(-5px);
                /* Punto más bajo del rebote */
            }
        }
    </style>
</head>

<body class="is-preload">
    <div id="wrapper" class="fade-in">
        <div id="intro">
            <h1><span class="image fit"><img id="logo" src="static/images/logo.png" alt="" /></span></h1>
            <div id="loading-spinner"
                style="display: none; position: absolute; top: 50%; left: 50%; transform: translate(-50%, -50%);">
                <div class="spinner-border" role="status" style="width: 6rem; height: 6rem;">
                    <span class="sr-only">Loading...</span>
                </div>
                <p id="loading-message">Indexing</p>
                <p id="progress-message">Indexing progress: <span id="progress-value">0%</span></p>
            </div>
            <form action="/indexing" id="form_submit" method="GET">
                <div class="row gtr-uniform">
                    <div class="col-md-auto">
                        <input type="url" required placeholder="Insert a Web sitemap " name="webSiteMap" />
                    </div>
                    <ul class="actions">
                        <li>
                            <input type="submit" value="Index Page" class="primary" id="index-button"
                                onclick="startIndexing()" />
                        </li>
                        <li>
                            <input type="button" value="Cancel" class="primary" id="cancel-button" disabled="true" onclick="cancelIndexing()" />
                        </li>
                    </ul>
                </div>
            </form>
            <div class="col-6 col-6-small" style="min-height: 100px;">
                <ul class="actions stacked">
                    <li><a href="/" class="button primary fit" style="width: 250px;" id="search-button">Search in your Database</a></li>
                </ul>
            </div>
        </div>
    </div>
    <!-- Scripts -->
    <script src="static/js/jquery.min.js"></script>
    <script src="static/js/jquery.scrollex.min.js"></script>
    <script src="static/js/jquery.scrolly.min.js"></script>
    <script src="static/js/browser.min.js"></script>
    <script src="static/js/breakpoints.min.js"></script>
    <script src="static/js/util.js"></script>
    <script src="static/js/main.js"></script>
    <script>

        function cancelIndexing() {
            // Restablece la variable de control y habilita el botón "Index Page"
            isIndexing = false;
            document.getElementById('index-button').disabled = false;

            // Deshabilita el botón de cancelar
            document.getElementById('cancel-button').disabled = true;

            // Muestra el botón "Search in your Database"
            document.getElementById('search-button').style.display = 'inline-block'; // o 'flex' según tu diseño

            // Muestra el logo "logo.png"
            document.getElementById('logo').style.display = 'block';

            // Oculta el spinner y el mensaje de indexación
            document.getElementById('loading-spinner').style.display = 'none';

            // Envía una solicitud al servidor para cancelar la indexación
            $.ajax({
                url: '/cancel_indexing',
                type: 'GET',
                success: function () {
                    console.log("Indexing canceled by user.");
                },
                error: function (error) {
                    console.log("Error canceling indexing:", error);
                }
            });
        }

        function startIndexing() {
            // Obtén el formulario y el campo de entrada
            var form = document.getElementById('form_submit');
            var webSiteMapInput = form.elements['webSiteMap'];

            // Verifica la validación del campo de entrada
            if (webSiteMapInput.checkValidity()) {
                // Deshabilita el botón "Index Page" para evitar múltiples clics
                document.getElementById('index-button').disabled = true;

                // Oculta el botón "Search in your Database"
                document.getElementById('search-button').style.display = 'none';

                // Oculta el logo "logo.png"
                document.getElementById('logo').style.display = 'none';

                // Muestra el spinner y el mensaje de indexación
                document.getElementById('loading-spinner').style.display = 'block';
                
                document.getElementById('cancel-button').disabled = false;

                // Envía el formulario
                form.submit();

                // Realizar solicitudes AJAX periódicas para obtener el progreso
                setInterval(function () {
                    $.ajax({
                        url: '/get_progress',
                        type: 'GET',
                        success: function (data) {
                            updatePercentage(data.percentage);
                        },
                        error: function (error) {
                            console.log("Error al obtener el progreso:", error);
                        }
                    });
                }, 1000); // Actualizar cada 1 segundo (ajusta según sea necesario)
            } else {
                // La validación no se ha cumplido, puedes mostrar un mensaje o realizar otras acciones aquí
                console.log("La validación del formulario no se ha cumplido");
                }
            }   

        function updatePercentage(percentage) {
            document.getElementById('progress-value').innerText = percentage.toFixed(2) + '%';
        }
    </script>
</body>

</html>
